#ifndef GAME_H
#define GAME_H

#include "world.h"
#include "player.h"
#include "state.h"

#include <SFML/Graphics/RenderWindow.hpp>
#include <SFML/Window/Keyboard.hpp>

class Game final : public State
{
public:
    Game(sf::RenderWindow& window, Application *application);
    virtual ~Game() override;

    void run();

private:
    World world;
    Player player;

    bool b_pause;
    bool b_to_right, b_to_left, b_to_up, b_to_down;

    bool processInput() override;
    bool update(const sf::Time& dt) override;
    void draw() override;
};

#endif // GAME_H
